package org.puremvc.as3.multicore.utilities.fabrication.injection
{
	import mx.core.IMXMLObject;
	import mx.core.UIComponent;
	import mx.events.FlexEvent;
	
	import org.as3commons.reflect.Type;
	import org.puremvc.as3.multicore.utilities.fabrication.interfaces.IClassInfoType;

	public class InjectConfigure implements IMXMLObject,IClassInfoType
	{
		public function InjectConfigure()
		{
		}
		
		private var injectionFieldsNames:Array ;
		
		private var classInfoType:Type;
		
		private var uicom:Object;
		
		/**
		 * @see mx.core.IMXMLObject#initialized
		 */
		public function initialized( document:Object, id:String ):void
		{
			uicom = document;			

			__initialized_ui();
		}
		
		public function setUIComponent( ui:UIComponent):void
		{
			if(ui != null){
				uicom = ui;
			}
			
			__initialized_ui();
		}
		
		private function __initialized_ui():void
		{
			if(uicom!=null){
				uicom.addEventListener(FlexEvent.REMOVE,removeHandle)
			}
				
			if(injectionFieldsNames != null) return ;
			
			injectionFieldsNames = [];
			injectionFieldsNames = InjectProcessorFactory.getInstance().inject(null,this)
		}
		
		private function removeHandle(e:FlexEvent):void
		{
			if(uicom!=null){
				uicom.removeEventListener(FlexEvent.REMOVE,removeHandle)
					
				dispose();
			}
			
			removeClassInfo()
		}
		
		public function dispose():void 
		{
			if (injectionFieldsNames) {
				var injectedFieldsNum:uint = injectionFieldsNames.length;
				for (var i:int = 0; i < injectedFieldsNum; i++) {
					
					var fieldName:String = ""+injectionFieldsNames[i];
					uicom[ fieldName ] = null;
				}
				injectionFieldsNames = null;
			}
			
			uicom = null;
			
			removeClassInfo()
		}
		
		public function getClassInfo():Type
		{
			if(classInfoType != null) return classInfoType;
			classInfoType = Type.forInstance(uicom);
			return classInfoType;
		}
		
		public function removeClassInfo():void
		{
			/*if(classInfoType!=null){
				classInfoType.dispose();
			}*/
			classInfoType = null
		}
		
		/**
		 * get inject name :
		 * sample: resProxy
		 */ 
		public function haveInjectName(nm:String):Boolean
		{
			return uicom[nm] != null
		}
		
		public function setInjectName(nm:String,obj:Object):void
		{
			uicom[nm] = obj
		}
	}
}