/**
 * Copyright (C) 2009 Darshan Sawardekar.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.puremvc.as3.multicore.utilities.fabrication.patterns.command.undoable {
	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.utilities.fabrication.patterns.command.SimpleFabricationCommand;		

	/**
	 * Changes the current undo group in the fabrication controller. The body of the notification
	 * is the name of the undo group to switch to.
	 * 
	 * @author Darshan Sawardekar
	 */
	public class ChangeUndoGroupCommand extends SimpleFabricationCommand {

		/*
		 * Changes the current undo group of the fabrication undo history.
		 */
		override public function execute(note:INotification):void {
			fabFacade.fabricationController.groupID = note.getBody() as String;
		} 		

	}
}