package org.puremvc.as3.multicore.utilities.fabrication.undo
{
	public class UndoHistroy
	{
		public function UndoHistroy()
		{
		}
		
		/**
		 * 一条队列存放已经执行过的command
		 */ 
		private var queue:Array = []
		/**
		 *  一条队列存放已经undo过的command
		 */ 
		private var undoQueue:Array = []
		
		/**
		 * 新command加入的时候，undo队列便被清空
		 */ 
		public function addNewCmd(cmd:IUndoCommand):void
		{
			undoQueue = []
			queue.push(cmd);
		}
		
		/**
		 * 检测新添加的和最后一个是否相同
		 */ 
		public function checkSameLast(s:*):Boolean
		{
			if(queue.length < 1) return false;
			return s == IUndoCommand(queue[queue.length-1]).getLastValue();
		}
		
		/**
		 * redo
		 */ 
		public function redo():void
		{
			if(undoQueue.length > 0)
			{
				var ic:IUndoCommand = undoQueue.pop() as IUndoCommand;
				ic.redo();
				
				queue.push(ic);
			}
		}
		
		/**
		 * undo
		 */ 
		public function undo():void
		{
			if(queue.length > 0)
			{
				//把队列尾部的command拿出来执行undo
				var ic:IUndoCommand = queue.pop() as IUndoCommand;
				ic.undo();
				
				//执行完后插入undoQueue
				undoQueue.push(ic);
			}
		}
		
		public function clear():void
		{
			for each(var ic:IUndoCommand in queue){
				if(ic!=null){
					ic.dispose();
					ic = null
				}
			}
			
			queue = null;
			queue = [];
			
			for each(ic in undoQueue){
				if(ic!=null){
					ic.dispose();
					ic = null
				}
			}
			
			undoQueue = null;
			undoQueue = [];
		}
	}
}